/*
  Copyright (c) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000  AXE,Inc.
 */

/*
	crystal.h
*/

#ifndef _CRYSTAL_H
#define _CRYSTAL_H

#include <xtal/xtaltypes.h>

/***	٥ȤδѤη	*/

/* ٥Ȥα黻ˡ */
#define EVOP_REPLACE	0		/* result = value */
#define EVOP_SET	0		/* result = value */
#define EVOP_AND	1		/* result = old_value &  value */
#define EVOP_OR		2		/* result = old_value |  value */
#define EVOP_XOR	3		/* result = old_value ^  value */
#define EVOP_NAND	4		/* result = ~(old_value &  value) */
#define EVOP_NOR	5		/* result = ~(old_value |  value) */
#define EVOP_NXOR	6		/* result = ~(old_value ^  value) */
#define EVOP_ANDN	7		/* result = (~old_value) &  value */

#define EVCOND_AND	16		/* result = allBitAnd(event & mask) */
#define EVCOND_OR	17		/* result =  allBitOr(event & mask) */

struct Event_pbox{
	BYTE4	value;		/* ٥Ȥα黻		*/
	BYTE4	mask;		/* ٥ȤΥޥ		*/
	BYTE4	op;		/* ٥Ȥα黻ˡ		*/
	BYTE4	timeout;	/* ॢȤ			*/
	BYTE4	result;		/* ٥Ȥξ			*/
	OBJECT_NAME sender;	/* Ǹ˥٥ȥåȤץ̾   */
	BYTE4  when;		/* Ǹ˥٥ȥåȤƥ */
};
#define EVENT_PBOX	struct Event_pbox

/* Joined٥Ȥmode */
#define JOEV_QWRITE	1
#define JOEV_QREAD	2
#define JOEV_SEM_SIGNAL	3
#define JOEV_SEM_WAIT	4



/***	ޥեδѤη	*/

struct Semaphore_pbox{
	OBJECT_NAME owner;	/* ߥޥե򤨤Ƥץ̾ */
	BYTE4 when;		/*ߤownerޥեΥƥ*/
};
#define SEMAPHORE_PBOX struct Semaphore_pbox

/***	QueueδѤη	*/

struct Queue_pbox{
	UBYTE  *data;		/* ǡؤΥݥ */
	BYTE4  size;		/* ǡΥ */
	BYTE4  timeout;		/* ॢȤλ */
	OBJECT_NAME sender;	/* ǡ̾ */
	BYTE4  when;		/* 礬ǡ򥭥塼󥰤Υƥ */
};
#define QUEUE_PBOX struct Queue_pbox


/***	ץδѤη	*/

/* struct Proc_info .type */
#define TASK		(0x01)		/* ʬץ */
#define THREAD		(0x02)		/* ʬץ */
#define SYSTEM_THREAD	(0x12)		/* ʬץ(SystemMode) */
#define SYSTEM_TASK	(0x11)		/* Task(SystemMode) X68K Only */

#define PROC_TASK_MASK	(0x0F)		/* Task/thread Mask */
#define PROC_MODE_MASK	(0xF0)		/* Sys/User Mask */

struct Proc_ini{
	BYTE4		type;		/* thread or Task */
	BYTE4		priority;	/* ͥٽ */
	OBJECT_NAME	code;		/* ץॳ̾ */
	BYTE4		stack_size;	/* å */
	OBJECT_NAME	data;		/* ǡΰ̾ */
	OBJECT_NAME	message;	/* ץΰ(Debug)*/
};
#define PROC_INI	struct Proc_ini

/***	dbg_reg_put(), dbg_reg_get()Υ쥸	*/
#define REG_R0		0
#define REG_R1		1
#define REG_R2		2
#define REG_R3		3
#define REG_R4		4
#define REG_R5		5
#define REG_R6		6
#define REG_R7		7
#define REG_R8		8
#define REG_R9		9
#define REG_R10		10
#define REG_R11		11
#define REG_R12		12
#define REG_R13		13
#define REG_R14		14
#define REG_R15		15
#define REG_SP		15

#define REG_SR		16
#define REG_GBR		17
#define REG_MACH	18
#define REG_MACL	19
#define REG_PR		20
#define REG_PC		21

/***	error number	*/

#define ERR_PAGEFAULT	0x80000000
#define ERR_TLB_MISS		0
#define ERR_TLB_MISS_DATA	1
#define ERR_TLB_MISS_STACK	2
#define ERR_TLB_MISS_DOWNLOAD	3
#define ERR_TLB_MISS_WINDOW	4
#define ERR_INIT_PAGE_WRITE	5
#define ERR_TLB_PROTECT_READ	6
#define ERR_TLB_PROTECT_WRITE	7
#define ERR_ADDRESS_ERROR_READ	8
#define ERR_ADDRESS_ERROR_WRITE	9
#define ERR_MEMORY_EXHAUST	10

/***** System Call procedures *****/


/* ƥ */

BYTE4 sys_gettime();
/*
	BYTE4 sys_gettime()

	ƥ֤֤
*/


OBJECT_NAME name_generate();

int code_create();
int code_delete();


/* ץ */

int proc_create();
/*
	int proc_create(name, pdata)
	OBJECT_NAME name;
	PROC_INI *pdata;
	֤	顼λϡݣ֤
		nameNAME_UNIQUEλ줿֤̾

	ץ
	ץ֤EXIST
*/


int proc_delete();
/*
	int proc_delete(name)
	OBJECT_NAME name;

	ץ
	顼λϡݣ֤
*/


int proc_start();
/*
	int proc_start(name)
	OBJECT_NAME name;

	ץ֤EXISTREADY˰ܹԤ
	顼λϡݣ֤
*/


int proc_stop();
/*
	int proc_stop(name)
	OBJECT_NAME name;

	ץ֤EXIST֤ˤ
	顼λϡݣ֤
*/



int proc_wakeup();
/*
	int proc_wakeup(name)
	OBJECT_NAME name;

	ץ֤SLEEPREADY֤˰ܹԤ
	顼λϡݣ֤
*/


int proc_sleep();
/*
	int proc_sleep(name,timeout)
	OBJECT_NAME name;
	BYTE4 timeout;

	ץ֤SLEEP֤ˤ
	顼λϡݣ֤
*/


int proc_setslice();
int proc_setpriority();

int self_sleep();
/*
	int self_sleep(timeout)
	BYTE4 timeout;

	SLEEP֤ˤ
	顼λϡݣ֤
*/


void self_end();
/*
	int self_end()

	ץä
	꥿󤷤ޤ
*/


OBJECT_NAME self_getname();
/*
	OBJECT_NAME
	self_getname()

	ץ֤̾
	顼ΤȤ-1
*/


int self_setslice();
int self_setpriority();
int self_grab_cpu();
int self_ungrab_cpu();


BYTE4 proc_get_lifetime();
/*
	BYTE4 proc_get_lifetime(name)
	OBJECT_NAME name;

	ץμ̿Ĵ٤
	顼λϡݣ֤
*/


BYTE4 self_get_lifetime();
/*
	BYTE4 self_get_lifetime()

	ץμ̿Ĵ٤
	顼λϡݣ֤
*/



/* 塼 */


int queue_create();
/*
	int queue_create(name, len, data_max_size)
	OBJECT_NAME name;
	BYTE4 len;
	BYTE4 data_max_size;
	֤	顼λϡݣ֤
		nameNAME_UNIQUEλ줿֤̾

		len 塼Ĺ
		data_max_size 塼ΰǡ

	塼
*/


int queue_delete();
/*
	int queue_delete(name)
	OBJECT_NAME name;

	塼
	顼λϡݣ֤
*/


int queue_read();
/*
	int queue_read(name, pbox)
	OBJECT_NAME name;
	QUEUE_PBOX *pbox;
	֤ 

	塼ǡɤ߽Ф
	顼λϡݣ֤
	ॢȤλϡݣ֤
*/


int queue_write();
/*
	int queue_write(name, pbox)
	OBJECT_NAME name;
	QUEUE_PBOX *pbox;
	֤ 

	塼˥ǡ񤭹
	顼λϡݣ֤
	ॢȤλϡݣ֤
*/


int queue_peek();
/*
	int queue_peek(name)
	OBJECT_NAME name;

		֤ 塼ˤǡ

	塼˥ǡĴ٤
	ǡʤϣ֤
	顼λϡݣ֤
*/


int queue_npeek();
/*
	int queue_npeek(name)
	OBJECT_NAME name;

		֤ 塼ˤǡ

	塼˥ǡĴ٤
	顼λϡݣ֤
*/



/* ٥ */



int event_create();
/*
	int event_create(name)
	OBJECT_NAME name;
	֤	顼λϡݣ֤
		nameNAME_UNIQUEλ줿֤̾

		name	٥̾

	٥Ȥ
*/


int event_delete();
/*
	int event_delete(name)
	OBJECT_NAME name;

		name	٥̾

	٥Ȥ
	顼λϡݣ֤
*/


BYTE4 event_get();
/*
	BYTE4 event_get(name)
	OBJECT_NAME name;

		name	٥̾

	٥Ȥͤɤ߽Фʥ٥ȤͤѲʤ
	顼λϡݣ֤
*/


int event_set();
/*
	int event_set(name,pbox)
	OBJECT_NAME name;
	EVENT_PBOX *pbox;

		name	٥̾
		*pbox	٥ΰ
			value,opˤäƱ黻Ԥޤ
			mask,reset_value,reset_op,timeoutϻȤޤ
			黻̤Υ٥ͤflags˳Ǽޤ

	٥Ȥ˥åȤ
	顼λϡݣ֤
*/


int event_wait();
/*
	int event_wait(name,pbox)
	OBJECT_NAME name;
	EVENT_PBOX *pbox;

		name	٥̾
		*pbox	٥Ԥΰ
			maskͤǥ٥Ȥͤ˥ޥݤ
			value,opˤäƱ黻Ԥη̤󣰤ˤʤä
			Ԥ֤ȴޤ
			Ԥ֤ȴ٥ȤФreset_valuereset_op
			α黻ԤޤॢȤˤϹԤޤ

	٥ȤԤޤ
	顼λϡݣ֤
*/




/* ޥե */

int semaphore_create();
/*
	int semaphore_create(name)
	OBJECT_NAME name;
	֤	顼λϡݣ֤
		nameNAME_UNIQUEλ줿֤̾

	ޥե
*/


int semaphore_delete();
/*
	int semaphore_delete(name)
	OBJECT_NAME name;

	ޥե
	顼λϡݣ֤
*/


int semaphore_wait();
/*
	int semaphore_wait(name,timeout,pbox)
	OBJECT_NAME name;
	BYTE4 timeout;
	SEMAPHORE_PBOX *pbox;		NULLλ̵뤷ޤ

	ޥե
	顼λϡݣ֤
	ॢȤλϡݣ֤ pbox˾֤
*/


int semaphore_signal();
/*
	int semaphore_signal(name)
	OBJECT_NAME name;

	ޥե
	顼λϡݣ֤
*/



/* ̾ */


#if 0
OBJECT_NAME unused_name_get();
/*
	OBJECT_NAME unused_name_get()

	̤Ѥ֤̾
	顼λNAME_NULL֤
*/
#endif

OBJECT_NAME str_to_name();
/*
	OBJECT_NAME str_to_name(str)
	char *str;
	֤		̾

	ʸ󤫤̾Ѵ
*/



void name_to_str();
/*
	void name_to_str(str,name)
	char *str;
	OBJECT_NAME name;

	̾ʸѴ
*/



int name_byte();
/*
	int name_byte(byte,name)
	unsigned char *byte;
	OBJECT_NAME name;

	̾ХѴƤΥ֤
*/


int byte_name();
/*
	int str_name(name,byte)
	OBJECT_NAME *name;
	unsigned char *byte;
	
	Х̾ѴƤΥ֤
*/



/***************************************************************************/


int kernel_init();
/*
	int kernel_init(name,pdata)
	OBJECT_NAME name;		ץ̾
	PROC_INI *pdata;		ץ

	ݥͥνԤ
	顼λϡݣ֤
*/


int name_info();
/*
	int name_info(name,info)
	OBJECT_NAME name;
	OBJECT_INFO *info;

	̾˴ؤɤ߽Ф
	̾ʤäϡݣ֤
*/




int name_list_first();
/*
	int name_list_first(info)
	NAME_INFO_LIST *info;
	֤͡ݣΤȤ٤Ƥ̾˴ؤϤ

	٤Ƥ̾ξĤļФ
	name_list_next()ȥåȤǻȤ
*/

int name_list_next();
/*
	int name_list_next(info)
	NAME_INFO_LIST *info;
	֤͡ݣΤȤ٤Ƥ̾˴ؤϤ

	٤Ƥ̾ξĤļФ

	name_list_next()Ϣ³ǸƤӤưĤľФ
	ܤθƽФname_list_first()Ȥinfo
	ƱΤϤʤФʤʤ
*/


/****************************************************************************/


int memory_create();
/*
	int memory_create( name, size )
	OBJECT_NAME name;
	BYTE4 size;		ݤ륵(byte)
	֤		顼ΤȤݣ֤
			nameNAME_UNIQUEλ줿֤̾

	ݤ
*/



int memory_delete();
/*
	int memory_delete( name )
	OBJECT_NAME name;
	֤		顼λݣ֤ޤ

	ޤ
*/

BYTE *memory_address();
/*
	BYTE *memory_address( name )
	OBJECT_NAME name;
	֤		顼ΤȤNULL

	name˳ݤƤ롢Υɥ쥹֤
*/

BYTE4 memory_getsize();
/*
	BYTE4 memory_getsize( name )
	OBJECT_NAME name;
	֤		顼ΤȤ-1

	name˳ݤƤ롢Υ֤
*/

/****************************************************************************/

int intrev_create();
/*
	int
	intrev_create( name, event )
	OBJECT_NAME name, event;
	֤ 顼λϡݣ
*/

int intrev_delete();
/*
	int
	intrev_delete( name )
	OBJECT_NAME name;
	֤ 顼λݣ֤
*/

int intrev_set();
/*
	int
	intrev_set( name )
	OBJECT_NAME name;
	֤ 顼λϡݣ֤

	٥ȥե饰
*/


/***************************************************************************/

void dbg_putstr();
void dbg_write();
void object_dbgdump();

/***************************************************************************/


int db_puts();
/*
	int db_puts( str )
	char *str;

	ʸɽ
*/

int db_puts_scr();	/* ƥ */

#endif _CRYSTAL_H
